import pygame as PG
import atexit as EXIT
import random as random
import time as time


class Puntje(dict):
    def __init__(self, gameboard, x, color, key):
        self.bord = gameboard
        self.x = x-16
        self.y = 0
        self.width = 32
        self.height = 32
        self.vel = 8
        self.color = color
        self.key = key


    def fall(self):
        self.y += self.vel
        PG.draw.rect(self.bord.win, self.color, (self.x, self.y, self.width, self.height))



class GuitarHero(object):

    def __init__(self):
        # De initialisatie van een spel

        # activate the pygame library .
        # initiate pygame and give permission
        # to use pygame's functionality.
        PG.init()
        self.font = PG.font.SysFont("castellar", 64)
        
        # create the display surface object
        # of specific dimension..e(500, 500).

        self.spelveld = (1200, 700)
        self.win = PG.display.set_mode(self.spelveld)

        # set the pygame window name
        PG.display.set_caption("guitar hero")

        # vallende puntjes
        self.puntjes_settings =[
            {'x': 300, "color": (255, 0, 0), 'key': PG.K_a},
            {'x': 500, "color": (0, 255, 0), 'key': PG.K_e},
            {'x': 700, "color": (255, 0, 255), 'key': PG.K_i},
            {'x': 900, "color": (255, 255, 0), 'key': PG.K_p}
            ]
        self.puntjes = [
            ]

        # score (de puntjes = goede pogingen)
        self.score = 0
        self.miss = 0
        self.wrong = 0.

        # zeker gaan dat alles goed afsluit
        EXIT.register(self.Quit)

    def run(self):
        # Indicates pygame is running
        self.running = True

        # infinite loop
        tijd = 0 # we tellen lus-iteraties; alle 0.5s komt er misschien een noot bij
        while self.running:
            # creates time delay of 10ms
            

            # iterate over the list of Event objects
            # that was returned by pygame.event.get() method.
            for event in PG.event.get():

                # if event object type is QUIT
                # then quitting the pygame
                # and program both.
                if event.type == PG.QUIT:

                    # it will make exit the while loop
                    self.running = False
            
            # stores keys pressed
            keys = PG.key.get_pressed()

            if keys[PG.K_q]:
                self.Quit()
                break

            self.PlayNotes(keys)


            # completely fill the surface object
            # with non-black colour
            self.win.fill((0, 100, 225))
            # self.win.blit(self.win, (0,0))

            # doelzone
            self.doel_y = [550, 650]
            PG.draw.rect(self.win, (0, 0, 230),(250,0, 100, 1000))
            PG.draw.rect(self.win, (0, 0, 230),(450,0, 100, 1000))
            PG.draw.rect(self.win, (0, 0, 230),(650,0, 100, 1000))
            PG.draw.rect(self.win, (0, 0, 230),(850,0, 100, 1000))
            PG.draw.rect(self.win, (120, 0, 0), (0,550, 1200, 100))


            # https://stackoverflow.com/questions/19733226/python-pygame-how-to-make-my-score-text-update-itself-forever
            scoretext = self.font.render(f"Score {self.score}, miss {self.miss}", 1, (0,0,0))
            self.win.blit(scoretext, (5, 10))

            # # het pijltje bewegen
            # self.pijl.move(keys)
            # self.pijl.teken()

            for puntje in self.puntjes:
                puntje.fall()

            # maak er nieuwe noten aan
            if tijd % 10 == 0:
                self.GeneratePuntjes()

            # it refreshes the window
            PG.display.update()

            # 0.1s wachten
            tijd += 1
            PG.time.delay(50)

    def PlayNotes(self, keys):
        checks = [] # goede clicks eventjes bewaren

        for puntje in self.puntjes:
            if (puntje.y > self.doel_y[0]) and (puntje.y < self.doel_y[1]):
                # puntje is in het doelveld

                if keys[puntje.key]:
                    checks.append(puntje.key)
                    # user drukt het juiste knopje
                    # print ("scored! :)")
                    self.score += 1
                    self.puntjes.remove(puntje)

            if puntje.y > self.doel_y[1] + 40:
                # print ("miss!")
                self.miss += 1
                self.puntjes.remove(puntje)


        for key in [PG.K_a, PG.K_e, PG.K_i, PG.K_p]:
            if keys[key] and not (key in checks):
                # print ("wrong :(")
                self.wrong += 0.05

    def GeneratePuntjes(self):
        for pts in self.puntjes_settings:
            # met een bepaalde kans puntjes aanmaken
            if random.uniform(0., 1.) < 0.2:
                self.puntjes.append(Puntje(self, **pts))


    def Quit(self):
        self.running = False
        # closes the pygame window
        PG.quit()
        print("bedankt om te spelen!")


# MISSION CONTROL
if __name__ == "__main__":
    game = GuitarHero()
    print ("start!")
    game.run()
